import java.net.*;

public aspect URLConn {

    /*
     * All those method calls are forbidden, once the connection is connected.
     */
    
    pointcut forbiddenMethodCalls():
        call(* URLConnection.setDoInput(..)) ||
        call(* URLConnection.setDoOutput(..)) ||
        call(* URLConnection.setAllowUserInteraction(..)) ||
        call(* URLConnection.setUseCaches(..)) ||
        call(* URLConnection.setIfModifiedSince(..)) ||
        call(* URLConnection.setRequestProperty(..)) ||
        call(* URLConnection.addRequestProperty(..)) ||
        call(* URLConnection.getRequestProperty(..)) ||
        call(* URLConnection.getRequestProperties(..));
    
	tracematch(URLConnection c) {
		
		sym create after returning(c): call(URLConnection URL+.openConnection()) && !within(dacapo..*); 
		sym connect after returning: call(* URLConnection.connect()) && target(c) && !within(dacapo..*); 
		sym setter before: forbiddenMethodCalls() && target(c);

		create connect setter {
            if(System.getProperty("TMTEST_ACTIVE")!=null) {
                System.err.println("##### Tracematch "+getClass().getName()+" matched!");
            }
		}
		
	}

}
